# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`rsyslog_client`](#rsyslog_client): Support for installation and configuration of rsyslog.

## Classes

### rsyslog_client

Support for installation and configuration of rsyslog. We support the bare minimum needed to
enable support on RHEL7, eg all legacy config/no rainer script. This is inline with the
default `rsyslog.conf` file installed by the vendor.

#### Examples

##### Install and enable rsyslog

```puppet
include rsyslog_client
```

##### Hiera data for general rsyslog settings

```puppet
rsyslog_client::settings:
  - '$FileOwner': 'root'
  - '$FileGroup': 'root'
  - '$FileCreateMode': '0600'
  - '$DirOwner': 'root'
  - '$DirGroup': 'root'
  - '$DirCreateMode': '0750'
```

##### Hiera data for rsyslog entries

```puppet
rsyslog_client::entries:
  'daemon.*': /var/log/daemon.log
  'syslog.*': /var/log/syslog
```

#### Parameters

The following parameters are available in the `rsyslog_client` class.

##### `service`

Data type: `String`

Name of rsyslog service to manage

Default value: "rsyslog"

##### `service_ensure`

Data type: `Enum['running','stopped']`

Ensure the service to this value

Default value: "running"

##### `service_enable`

Data type: `Boolean`

Enable the service at boot?

Default value: `true`

##### `settings`

Data type: `Array[Hash[String,Any]]`

Settings to insert into the `rsyslog.conf` file. Existing definitions will be
replaced in-place. If a setting is added that doesn't already exist, it will be inserted
into the file _from_ line `setting_insertion_line`. Settings will be processed in array
order (see examples)

Default value: []

##### `entries`

Data type: `Hash[String,Any]`

Hash of logging entries to create (see examples)

Default value: {}

##### `config_file`

Data type: `String`

configuration file to write

Default value: "/etc/rsyslog.conf"

##### `settings_insertion_line`

Data type: `Integer`

If a setting needs to be inserted, insert starting at this line
(zero indexed)

Default value: 23

##### `package`

Data type: `String`



Default value: "rsyslog"

